=== debian/changelog ===
cyclonedds (0.8.2-5) unstable; urgency=medium

  * Fix M-A: same issue with cyclonedds-dev

 -- Timo Röhling <roehling@debian.org>  Wed, 26 Jan 2022 19:43:23 +0100

cyclonedds (0.8.2-4) unstable; urgency=medium

  * Add missing -dev depend on Iceoryx

 -- Timo Röhling <roehling@debian.org>  Tue, 25 Jan 2022 10:14:49 +0100

cyclonedds (0.8.2-3) unstable; urgency=medium

  * Add more supported architectures for Iceoryx

 -- Timo Röhling <roehling@debian.org>  Mon, 24 Jan 2022 22:48:56 +0100

cyclonedds (0.8.2-2) unstable; urgency=medium

  * Enable Iceoryx SHM backend on supported architectures

 -- Timo Röhling <roehling@debian.org>  Mon, 24 Jan 2022 15:38:31 +0100

cyclonedds (0.8.2-1) unstable; urgency=medium

  * New upstream version 0.8.2

 -- Timo Röhling <roehling@debian.org>  Thu, 13 Jan 2022 14:01:41 +0100

cyclonedds (0.8.1-5) unstable; urgency=medium

  * Fix symbols for kfreebsd-any

 -- Timo Röhling <roehling@debian.org>  Wed, 15 Dec 2021 20:10:59 +0100

cyclonedds (0.8.1-4) unstable; urgency=medium

  * Also fix PATH_MAX (FTBFS on hurd-any)

 -- Timo Röhling <roehling@debian.org>  Thu, 28 Oct 2021 20:27:50 +0200

cyclonedds (0.8.1-3) unstable; urgency=medium

  * Fix compilation error on hurd-any

 -- Timo Röhling <roehling@debian.org>  Thu, 28 Oct 2021 17:19:41 +0200
