=== debian/control ===
Source: cyclonedds
Section: libs
Priority: optional
Maintainer: Debian Robotics Team <team+robotics@tracker.debian.org>
Uploaders: Timo Röhling <roehling@debian.org>
Build-Depends: debhelper-compat (= 13),
               bison,
               cmake,
               cyclonedds-tools <cross>,
               dh-sequence-sphinxdoc <!nodoc>,
               doxygen <!nodoc>,
               graphviz <!nodoc>,
               libcunit1-dev <!nocheck>,
               libiceoryx-binding-c-dev [amd64 arm64 mips64el ppc64el s390x alpha ia64 ppc64 riscv64 sparc64],
               libssl-dev,
               python3-exhale <!nodoc>,
Standards-Version: 4.6.0
Rules-Requires-Root: no
Homepage: https://projects.eclipse.org/projects/iot.cyclonedds
Vcs-Git: https://salsa.debian.org/robotics-team/cyclonedds.git
Vcs-Browser: https://salsa.debian.org/robotics-team/cyclonedds

Package: libddsc0
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Eclipse Cyclone DDS library
 Eclipse Cyclone DDS is a very performant and robust open-source
 implementation of the Data Distribution Service (DDS) standard by the
 Object Management Group (OMG) and the related wire protocol for
 interoperability (RTPS). It is developed completely in the open as an
 Eclipse IoT project with a growing list of adopters, and has become a
 tier-1 middleware for the Robot Operating System (ROS 2).

Package: libcycloneddsidl0
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Eclipse Cyclone DDS IDL library
 Eclipse Cyclone DDS is a very performant and robust open-source
 implementation of the Data Distribution Service (DDS) standard by the
 Object Management Group (OMG) and the related wire protocol for
 interoperability (RTPS). It is developed completely in the open as an
 Eclipse IoT project with a growing list of adopters, and has become a
 tier-1 middleware for the Robot Operating System (ROS 2).
 .
 This package provides the Interface Definition Language (IDL) compiler
 library. IDL is used to specify data exchange formats for participants
 in a DDS network.

Package: cyclonedds-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Recommends: cyclonedds-tools
Depends: ${misc:Depends},
         libddsc0 (= ${binary:Version}),
         libcycloneddsidl0 (= ${binary:Version}),
         libiceoryx-binding-c-dev [amd64 arm64 mips64el ppc64el s390x alpha ia64 ppc64 riscv64 sparc64],
Breaks: libddsc-dev (<< 0.8.1-1)
Replaces: libddsc-dev (<< 0.8.1-1)
Description: Eclipse Cyclone DDS library - development headers
 Eclipse Cyclone DDS is a very performant and robust open-source
 implementation of the Data Distribution Service (DDS) standard by the
 Object Management Group (OMG) and the related wire protocol for
 interoperability (RTPS). It is developed completely in the open as an
 Eclipse IoT project with a growing list of adopters, and has become a
 tier-1 middleware for the Robot Operating System (ROS 2).
 .
 This package installs the development headers.

Package: cyclonedds-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends: ${sphinxdoc:Depends}, ${misc:Depends}
Breaks: libddsc-doc (<< 0.8.1-1)
Replaces: libddsc-doc (<< 0.8.1-1)
Description: Eclipse Cyclone DDS library - API documentation
 Eclipse Cyclone DDS is a very performant and robust open-source
 implementation of the Data Distribution Service (DDS) standard by the
 Object Management Group (OMG) and the related wire protocol for
 interoperability (RTPS). It is developed completely in the open as an
 Eclipse IoT project with a growing list of adopters, and has become a
 tier-1 middleware for the Robot Operating System (ROS 2).
 .
 This package installs the API documentation.

Package: cyclonedds-tools
Section: devel
Architecture: any
Multi-Arch: foreign
Depends: ${shlibs:Depends}, ${misc:Depends}
Breaks: libddsc-tools (<< 0.8.1-1)
Replaces: libddsc-tools (<< 0.8.1-1)
Description: Eclipse Cyclone DDS tools
 Eclipse Cyclone DDS is a very performant and robust open-source
 implementation of the Data Distribution Service (DDS) standard by the
 Object Management Group (OMG) and the related wire protocol for
 interoperability (RTPS). It is developed completely in the open as an
 Eclipse IoT project with a growing list of adopters, and has become a
 tier-1 middleware for the Robot Operating System (ROS 2).
 .
 This package installs the command-line tools for Cyclone DDS, most
 importantly the Interface Definition Language (IDL) compiler, which is
 needed to specify data exchange formats for the participants in a DDS
 network.
