=== debian/tests/control ===
Tests: hello-world
Depends: @, cmake, build-essential
